#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <FastLED.h>

byte NUM_LEDS = 48; //48
CRGB leds[48];

byte code = 0;
byte page = 1;
byte Position = 0;
byte color = 0;
unsigned long timeNow = 0;

int r = 0;
int g = 0;
int b = 0;
int bri = 255;

const byte maxPage = 6;

// For Receiver
RF24 radio(10, 9); // CE, CSN
const byte address[6] = "00001";

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  FastLED.addLeds<WS2812B, 3, GRB>(leds, NUM_LEDS); //0
  radio.begin();
  radio.openReadingPipe(0, address);
  radio.startListening();
}

void loop() {
  listening();
  // put your main code here, to run repeatedly:
  if(code == 1){
    if(page > 1){
      page = page-1; 
    }
    code = 0;
  }
  if(code == 2){
    if(page <= maxPage){
      page = page +1;
    }
    code = 0;
  }
  if(page <= 4){ //to not call solid colors multiple times
   solidColors();
   code = 0;
  }
  if(page >= 5){ //run through animations.
    runAnimations();
  }
}

void runAnimations(){
  if(page == 5){
    if(code == 3){
      MoveRainbow();
    }else if(code == 4){
      GradualRainbow();
    }else if(code == 5){
      SpiralSpin();
    }else if(code == 6){
      RandomWipe();
    }else if(code == 7){
      Erase(0);
    }else if(code == 8){
      Juggle();
    }else if(code == 9){
      LineSpin();
    }else if(code == 10){
      LineSpinRemove();
    }else if(code == 11){
      Hoop(false); //solid color hoop
    }else if(code == 12){
      Hoop(true); //random color hoop
    }
  }
  if(page == 6){
    if(code == 3){
      Travel(false);
    }else if(code == 4){
      Travel(true);
    }else if(code == 5){
      RainbowTravel();
    }else if(code == 6){

    }else if(code == 7){

    }else if(code == 8){

    }else if(code == 9){

    }else if(code == 10){

    }else if(code == 11){

    }else if(code == 12){

    }
  }
  FastLED.show();
}

void solidColors(){
  if(page == 1){
    if(code == 3){
      setColor(0); //Red
    }else if(code == 4){
      setColor(26); //Orange
    }else if(code == 5){
      setColor(52); //Yellow
    }else if(code == 6){
      setColor(78); //Lime Green
    }else if(code == 7){
      setColor(104); //Teal
    }else if(code == 8){
      setColor(130); //Teal Green
    }else if(code == 9){
      setColor(156); //Light Blue
    }else if(code == 10){
      setColor(182); //Blue
    }else if(code == 11){
      setColor(208); //Purple
    }else if(code == 12){
      r = 255;
      g = 255;
      b = 255;
      setRGB();
    }
  }else if(page == 2){
     if(code == 3){ //White
      for(byte i = 0; i< NUM_LEDS; i++){
          if(i < NUM_LEDS/3){ //Red
            leds[i].setRGB(255, 0, 0);
          }else if(i >= NUM_LEDS/3 && i < NUM_LEDS/3*2){ //White
            leds[i].setRGB(255, 255, 255);
          }else{ //Blue
            leds[i].setRGB(0, 0, 255);
          }
      }
     }else if(code == 4){
      fill_rainbow(leds, NUM_LEDS, 0, 5);
     }else if(code == 5){
      fill_rainbow(leds, NUM_LEDS, 0, NUM_LEDS);
     } else if(code == 6){
      fill_rainbow(leds, NUM_LEDS, NUM_LEDS/2, NUM_LEDS/2);
     }else if(code == 7){
      // Decrease R
      if(r >= 15){
        r -= 15;
      }
      setRGB();
     }else if(code == 8){
      // Increase R
      if(r <= 240){
        r += 15;
      }
      setRGB();
     }else if(code == 9){
      // Decrease G
      if(g >= 15){
        g -= 15;
      }
      setRGB();
     }else if(code == 10){
      // Increase G
      if(g <= 240){
        g += 15;
      }
      setRGB();
     }else if(code == 11){
      // Decrease b
      if(b >= 15){
        b -= 15;
      }
      setRGB();
     }else if(code == 12){
      // Increase B
      if(b <= 240){
        b += 15;
      }
      setRGB();
     }  
  }else if(page == 3){
    if(code == 3){
      fill_gradient(leds, 0, CHSV(0, 255, 255), NUM_LEDS, CHSV( 45, 255, 255), SHORTEST_HUES);
    }else if(code == 4){
      fill_gradient(leds, 0, CHSV(100, 255, 255), NUM_LEDS, CHSV( 290, 255, 255), SHORTEST_HUES);
    }else if(code == 5){
      fill_gradient(leds, 0, CHSV(180, 255, 255), NUM_LEDS, CHSV( 230, 255, 255), SHORTEST_HUES);
    }else if(code == 6){
     fill_gradient(leds, 0, CHSV(120, 255, 255), NUM_LEDS, CHSV( 30, 255, 255), SHORTEST_HUES);
    }else if(code == 7){
     fill_gradient(leds, 0, CHSV(0, 255, 255), NUM_LEDS, CHSV( 180, 255, 255), SHORTEST_HUES);
    }else if(code == 8){
    fill_gradient(leds, 0, CHSV(240, 255, 255), NUM_LEDS, CHSV( 300, 255, 255), SHORTEST_HUES);
    }else if(code == 9){
     fill_gradient(leds, 0, CHSV(60, 255, 255), NUM_LEDS, CHSV( 270, 255, 255), SHORTEST_HUES);
    }else if(code == 10){
    fill_gradient(leds, 0, CHSV(0, 255, 255), NUM_LEDS, CHSV( 160, 255, 255), SHORTEST_HUES);
    }else if(code == 11){
    fill_gradient(leds, 0, CHSV(110, 255, 255), NUM_LEDS, CHSV( 40, 255, 255), SHORTEST_HUES);
    }else if(code == 12){
    fill_gradient(leds, 0, CHSV(315, 255, 255), NUM_LEDS, CHSV( 180, 255, 255), SHORTEST_HUES);
    }
  }else if(page == 4){
    if(code == 3){
      fill_gradient(leds, NUM_LEDS, CHSV(0, 255, 255), CHSV( 120, 255, 255), CHSV( 270, 255, 255), SHORTEST_HUES);
    }else if(code == 4){
      fill_gradient(leds, NUM_LEDS, CHSV(230, 255, 255), CHSV( 180, 255, 255), CHSV( 230, 255, 255), SHORTEST_HUES);
    }else if(code == 5){
      fill_gradient(leds, NUM_LEDS, CHSV(0, 255, 255), CHSV( 50, 255, 255), CHSV( 0, 255, 255), SHORTEST_HUES);
    }else if(code == 6){
     fill_gradient(leds, NUM_LEDS, CHSV(270, 255, 255), CHSV( 180, 255, 255), CHSV( 220, 255, 255), SHORTEST_HUES);
    }else if(code == 7){
     fill_gradient(leds, NUM_LEDS, CHSV(300, 255, 255), CHSV( 120, 255, 255), CHSV( 0, 255, 255), SHORTEST_HUES);
    }else if(code == 8){
    fill_gradient(leds, NUM_LEDS, CHSV(255, 255, 255), CHSV( 150, 255, 255), CHSV( 280, 255, 255), SHORTEST_HUES);
    }else if(code == 9){
    fill_gradient(leds, NUM_LEDS, CHSV(180, 255, 255), CHSV( 270, 255, 255), CHSV( 0, 255, 255), SHORTEST_HUES);
    }else if(code == 10){
    fill_gradient(leds, NUM_LEDS, CHSV(60, 255, 255), CHSV( 180, 255, 255), CHSV( 120, 255, 255), SHORTEST_HUES);
    }else if(code == 11){
    fill_gradient(leds, NUM_LEDS, CHSV(30, 255, 255), CHSV( 90, 255, 255), CHSV( 60, 255, 255), SHORTEST_HUES);
    }else if(code == 12){
    fill_gradient(leds, NUM_LEDS, CHSV(0, 255, 255), CHSV( 360, 255, 255), CHSV( 0, 255, 255), SHORTEST_HUES);
    }
  }
      FastLED.show();
}
  void setRGB(){
    for(int i = 0; i < NUM_LEDS; i++){
      leds[i].setRGB(r, g, b);
    }
  }
void RainbowTravel(){
    if(millis() > timeNow + 50){
      FastLED.clear();
      fill_rainbow (leds, Position, 0, 50);
      Position++;
      if(Position >= NUM_LEDS){
        FastLED.clear();
        Position = 0;
      }
      FastLED.show();
      timeNow = millis();
  }
}
void Travel(boolean pickRandomColor){
    if(millis() > timeNow + 50){
      FastLED.clear();
      leds[Position].setHSV(color, 255, 255);
      leds[Position+1].setHSV(color, 255, 255);
      leds[Position+2].setHSV(color, 255, 255);
      leds[Position+3].setHSV(color, 255, 255);
      leds[Position+4].setHSV(color, 255, 255);
      if(Position+5 == NUM_LEDS){
        Position = 0;
        if(pickRandomColor){
         color = random(255);
        }
      }else{
        Position++;
      }
      FastLED.show();
      timeNow = millis();
  }
}
void Hoop(boolean pickRandomColor){
    if(millis() > timeNow + 125){
      FastLED.clear();
      leds[Position].setHSV(color, 255, 255);
      leds[Position+1].setHSV(color, 255, 255);
      leds[Position+2].setHSV(color, 255, 255);
      leds[Position+3].setHSV(color, 255, 255);
      leds[Position+4].setHSV(color, 255, 255);
      if(Position <= 40){
        Position += 5;
      }else{
      leds[45].setHSV(color, 255, 255);
      leds[46].setHSV(color, 255, 255);
      leds[47].setHSV(color, 255, 255);
      leds[48].setHSV(color, 255, 255);
      if(pickRandomColor){
        color = random(255);
      }
      Position = 0;
      }
      FastLED.show();
      timeNow = millis();
  }
}
void MoveRainbow() {
  uint8_t beatA = beatsin8(17, 0, 255);
  uint8_t beatB = beatsin8(15, 0, 255);
  fill_rainbow(leds, NUM_LEDS, (beatA + beatB) / 2, 6);
}
//Long then short rainbow
void GradualRainbow() {
  uint8_t starthue = beatsin8(5, 0, 255);
  uint8_t endhue = beatsin8(7, 0, 255);
  if (starthue < endhue) {
    fill_gradient(leds, NUM_LEDS, CHSV(starthue, 255, 255), CHSV(endhue, 255, 255), FORWARD_HUES); // If we don't have this, the colour fill will flip around.
  } else {
    fill_gradient(leds, NUM_LEDS, CHSV(starthue, 255, 255), CHSV(endhue, 255, 255), BACKWARD_HUES);
  }
}
void RandomWipe() {
    if (millis() > timeNow + 100) {
      if(Position < NUM_LEDS){
      leds[Position].setHSV(color, 255, 255);
      Position++;
    }else{
      color = random(255);
      Position = 0;
    }
    timeNow = millis();
  }
}

  void SpiralSpin(){
    if (millis() > timeNow + 200) {
     if(Position >= 9){
       color = random(255);
      Position = 0;
      }
      leds[Position*5].setHSV(color, 255, 255);
      leds[Position*5+1].setHSV(color, 255, 255);
      leds[Position*5+2].setHSV(color, 255, 255);
      leds[Position*5+3].setHSV(color, 255, 255);
      leds[Position*5+4].setHSV(color, 255, 255);
      leds[Position*5+5].setHSV(color, 255, 255);
      leds[Position*5+6].setHSV(color, 255, 255);
      leds[Position*5+7].setHSV(color, 255, 255);
      leds[Position*5+8].setHSV(color, 255, 255);
      if(Position == 8){
        leds[NUM_LEDS].setHSV(color, 255, 255);
      }else{
        leds[NUM_LEDS].setHSV(color, 0, 0);
      }
      Position++;
      FastLED.show();
      timeNow = millis();
   }
  }
    void LineSpin(){
    if (millis() > timeNow + 100) {
     if(Position % 5 ==  0){
      color = random(255);
      Position = 0;
      }
      leds[Position].setHSV(color, 255, 255);
      leds[Position+5].setHSV(color, 255, 255);
      leds[Position+10].setHSV(color, 255, 255);
      leds[Position+15].setHSV(color, 255, 255);
      leds[Position+20].setHSV(color, 255, 255);
      leds[Position+25].setHSV(color, 255, 255);
      leds[Position+30].setHSV(color, 255, 255);
      leds[Position+35].setHSV(color, 255, 255);
      leds[Position+40].setHSV(color, 255, 255);
      leds[48].setHSV(color, 255, 255);
      Position++;
      timeNow = millis();
   }
  }
  void LineSpinRemove(){
    if (millis() > timeNow + 100) {
     if(Position % 5 ==  0){
      color = random(255);
      Position = 0;
      }
      FastLED.clear();
      leds[Position].setHSV(color, 255, 255);
      leds[Position+5].setHSV(color, 255, 255);
      leds[Position+10].setHSV(color, 255, 255);
      leds[Position+15].setHSV(color, 255, 255);
      leds[Position+20].setHSV(color, 255, 255);
      leds[Position+25].setHSV(color, 255, 255);
      leds[Position+30].setHSV(color, 255, 255);
      leds[Position+35].setHSV(color, 255, 255);
      leds[Position+40].setHSV(color, 255, 255);
      leds[NUM_LEDS].setHSV(color, 255, 255);
      Position++;
      timeNow = millis();
   }
  }
  void Erase(byte x) {
    // running red stripes
    for (uint16_t i = 0; i < NUM_LEDS; i++) {
      uint8_t fade = (millis() / 3) + (i * 24);
      if (fade % 256 == 0 && i == 0) {
        fade = 0;
      }
      leds[i] = CHSV(x, 255, fade);
    }
  }
    void Juggle() {
    fadeToBlackBy( leds, NUM_LEDS, 20);
    byte dothue = 0;
    for ( byte i = 0; i < NUM_LEDS / 6; i++) {
      leds[beatsin16( i + 7, 0, NUM_LEDS - 1 )] |= CHSV(dothue, 150 + random8(25), 200 + random8(50));
      dothue += 32;
    }
  }
  void setColor(byte h){
    for(int i = 0; i < NUM_LEDS; i++){
      leds[i].setHSV(h, 255, 255);
    }
  }
  char text[9];
  void listening(){
    if (radio.available()) {
      code = 0;
      radio.read(&text, sizeof(text));
      char * pch;
      pch = strtok (text,"\,");
      bri = 0;
      code = 0;
      while (pch != NULL)
      {
        if(code == 0){
          code = atoi(pch);
        }
      pch = strtok (NULL, ",");     // get next token if needed
     } 
     color = random(255);
    }
  }
